<?php

// PENDING : a revoir

class BackLabel {

    var $sql = null;
    var $name;
    var $align;
    var $format;
    var $abr;
    var $comment;
    var $option;
    var $param;
    var $valueSql;
 // valeur sql
    var $multi = false;
    var $order = true;
    var $curID;
  //id de la ligne en cours (%ID%
    var $pos;

    public function __construct($name, $format = '', $abr = '')
    {

        // Instance de la classe Site_SQL
        $this->sql = SiteSQL::getInstance();

        $this->name = $name;
        $this->format = $format;
        $this->abr = $abr;

        switch ($this->format) {
            case "statut":
                $this->align = "center";
                break;
            case "label":
                $this->align = "center";
                break;
            case "actif":
                $this->align = "center";
                break;
            case "action":
                $this->align = "center";
                break;
            case "translate":
                $this->multi = true;
                $this->order = false;
                break;
            case "image":
                $this->order = false;
                break;
            case "pdf":
                $this->order = false;
                $this->format = '';
                break;
            case "custom":
                $this->order = false;
                break;
            case "custom_v2":
                $this->order = false;
                break;
            case "left":
                $this->align = "left";
                $this->format = '';
                break;
            case "html":
                $this->align = "left";
                break;
            default:
                break;
        }
    }

    function setVar($var, $value) {
        $this->$var = $value;
    }

    function getVar($var) {
        return $this->$var;
    }

    function displayName($module) {
        $out = "";
        if (!$this->multi || ($this->multi == true && MULTI)) {
            $out .= "<th";


            $width = '';
            $align = (($this->align) ? 'text-align:' . $this->align . '' : '');

            $style = 'style="' . $width . $align . '"';

            $iconSort = '';

            if (empty($module->parent_url)) {
                $iconSort = 'fa-sort';

                if (abs($module->getVar('orderBy')) === $this->pos && $module->getVar('orderBy') < 0) {
                    $out .= " class='sort desc active'";
                    $iconSort = 'fa-sort-desc';
                } elseif (abs($module->getVar('orderBy')) === $this->pos && $module->getVar('orderBy') > 0) {
                    $out .= " class='sort asc active'";
                    $iconSort = 'fa-sort-asc';
                } elseif (!$this->order) {
                    $out .= " class='text'";
                }

            }

            if ($this->pos == 2 && $module->droits['CONTEXT'] && $module->droits['MOD'])
                $out .= " colspan='2'";

            $out.= " " . $style . ">";

            $abr = '';
            if ($this->abr) {
                $abr = " <i data-toggle=\"tooltip\" title='" . htmlentities($this->name) . "' style='cursor:help' class='fa  fa-question-circle'></i>";
            }

            if ($this->abr)
                $title = $this->abr;
            else
                $title = $this->name;

            if (!$this->order || !empty($this->valueSql))
                $out .= $abr  . $title;
            else {
                if ($module->getVar('orderBy')) {
                    if (abs($module->getVar('orderBy')) === $this->pos && $module->getVar('orderBy') > 0) {
                        $out .= "<a style='color:#000000' class='show' href='" . $module->orderUrl(-$this->pos) . "'>";

                    } else {
                        $out .= "<a style='color:#000000' class='show' href='" . $module->orderUrl($this->pos) . "'>";
                    }

                    $out.= $abr . ' ' . $title . ' <i class="fa '.$iconSort.' pull-right"></i>';
                    $out.= '</a>';
                }
            }

            $out .= "</th>";
        }
        return $out;
    }

    function DisplayData($module, $data) {
        $out = "";
        $class = "";

        if (!$this->multi || ($this->multi == true && MULTI)) {

            if (abs($module->getVar('orderBy')) === $this->pos)
                $class .= "sort";
            elseif (!$this->order)
                $class = "text";
            else
                $class = "";



            $align = (($this->align) ? 'style="text-align:' . $this->align . '"' : '');

            $out .= "<td " . $align . " class='" . $class . "'>";

            if (!empty($this->valueSql)) {
                $sql = str_replace('%DATA%', $data, $this->valueSql);
                $sql = str_replace('%ID%', $this->curID, $sql);
                $this->sql->query($sql, SQL_INIT, SQL_INDEX);
                $data = $this->sql->record[0];
            }

            if ($data == '--') {
                $out .= $data;
            } else {

                switch ($this->format) {
                    case "actif":
                        $name_url = (($this->option) ? $this->option : $module->name_url);
                        $status = ($data == 2) ? 'off' : 'on';
                        $color = ($data == 2) ? 'text-red' : 'text-green';
                        $out.= "<i style='cursor:pointer;' class='fa fa-2x fa-toggle-".$status." ".$color."' id='" . $name_url . "_" . $this->curID . "' onclick=\"switch_actif('" . $name_url . "','" . $this->curID . "','actif')\"></i>";
                        break;
                    case "statut":
                        $name_url = (($this->option) ? $this->option : $module->name_url);
                        $status = ($data == 2) ? 'off' : 'on';
                        $color = ($data == 2) ? 'text-red' : 'text-green';
                        $out.= "<i style='cursor:pointer;' class='fa fa-2x fa-toggle-".$status." ".$color."' id='" . $name_url . "_" . $this->curID . "' onclick=\"switch_actif('" . $name_url . "','" . $this->curID . "','" . $name_url . "_statut')\"></i>";
                        break;
                    case "statut_v2":
                        $name_url = (($this->option) ? $this->option : $module->name_url);
                        $out.= "<div class='divjs' onclick=\"show_status(this,'" . $name_url . "','" . $this->curID . "','" . $name_url . "_statut')\"><img class='imgjs' alt='switch_statut' id=\"" . $name_url . "_" . $this->curID . "\" src=\"" . $data . "\" /><img class='img_down' src='/back/styles/images/nav_dwn1.gif' alt='' /></div>";
                        break;

                    // TODO
                    case "statut_boutique":
                        $name_url = (($this->option) ? $this->option : $module->bases[0]);

                        $sql ="SELECT boutique_statut_id AS id, boutique_statut_nom AS label, boutique_statut_image as image FROM boutique_statut ORDER BY boutique_statut_rang";
                        $results = $this->sql->getAll($sql);
                        $dataSource = array();
                        $label = '';
                        foreach ($results as $result) {
                            $dataSource[] = array('value' => $result['id'], 'text' => $result['label']);
                            $label = ($result['id'] == $data) ? $result['label'] : $label;
                        }

                        $uniqueId = uniqid('sb-');

                        $out.= '<a href="#null" id="'.$uniqueId.'">'.$label.'</a>';

                        $out.= "<script>
                                    jQuery('#".$uniqueId."').editable({
                                        type:  'select',
                                        name: '".$name_url."',
                                        pk:    '".$this->curID."',
                                        url:   '/back/js/ajax/status_boutique.php',
                                        title:   'Statut',
                                        // mode: 'inline',
                                        value: ".$data.",
                                        source: ".json_encode($dataSource)."
                                    });
                                </script>";

                        break;

                    // TODO
                    case 'statut_boutique_listing':
                        // TODO : recup toutes les boutiques et pour chaque boutiques remonte le statut de la lignes
                        $boutiques = Boutique::getInstance()->get();
                        foreach($boutiques as $b) {
                            $name_url = (($this->option) ? $this->option : $module->bases[0]);
                            $sql = "SELECT boutique_statut_image FROM ".$name_url."_boutique ab LEFT JOIN boutique_statut bs ON(ab.".$name_url."_boutique_statut_id = bs.boutique_statut_id) WHERE ab.".$name_url."_id = '".$this->curID."' AND ab.boutique_id = '".$b['boutique_id']."'";
                            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                            $data = $this->sql->record[0]['boutique_statut_image'];
                            if ((isset($_SESSION['back_boutique_id']) && $_SESSION['back_boutique_id'] == $b['boutique_id']) || !isset($_SESSION['back_boutique_id'])) {
                                $out .= "<div>" . (!isset($_SESSION['back_boutique_id']) ? '<p style="float:left;width:68%;padding-right:5px;line-height:20px;font-size:.75em">' . $b['boutique_nom'] . '</p>' : null);
                                $out .= "<div class='divjs' " . (!isset($_SESSION['back_boutique_id']) ? "style=\"float:left;width:25%\"" : null ) . " onclick=\"show_status_boutique(this,'" . $name_url . "','" . $this->curID . "_" . $b['boutique_id'] . "','" . $name_url . "_boutique_statut')\"><img class='imgjs' alt='switch_statut' id=\"" . $name_url . "_" . $this->curID . "_" . $b['boutique_id'] . "\" src=\"" . $data . "\" /><img class='img_down' src='/back/styles/images/nav_dwn1.gif' alt='' /></div>";
                                $out .= "</div>";
                            }
                        }
                        break;

                    // TODO
                    case "default":
                        //$def_status = $module->isDefault($target_table,$data['id']);
                        if ($data)
                            $out.= "<img onclick=\"setDefault('" . $module->name_url . "','" . $module->parent_url . "','" . $this->curID . "','1','" . $module->link_to('searchList') . "')\" style='cursor:pointer' src='" . BACK_URL . "styles/images/bullet_star.png' alt='default' border='0' height='20' width='20' />";
                        else
                            $out.= "<img onclick=\"setDefault('" . $module->name_url . "','" . $module->parent_url . "','" . $this->curID . "','1','" . $module->link_to('searchList') . "')\" style='cursor:pointer' src='" . BACK_URL . "styles/images/bullet_white.png' alt='default' border='0' height='20' width='20' />";
                        break;
                    case "date":
                        if (!empty($data))
                            $out .= date(str_replace('%', '', $this->option[0]), strtotime($data));
                        else
                            $out .= "";
                        break;

                    // TODO
                    case "image":
                        //$out .= $data;
                        if (strpos($data, '|') !== false)
                            list($data, $infos) = explode('|', $data);

                        $infos = parse_url($data);
                        $src = str_replace(MEDIA_DIR, '/', rtrim(SITE_DIR, '/') . $infos['path']);
                        $params = ['height' => 35, 'width' => 35];

                        $out .= "<img alt='' src='";
                        $out .= (new Imager())->imager($src, $params, false);

                        if (empty($infos))
                            $out .= "' />";
                        else
                            $out .= "' class='infobulle' title='Informations::" . $infos . "' />";

                        break;
                    case "image_produit":

                        $infos = parse_url($data);
                        $src = str_replace(MEDIA_DIR, '/', rtrim(SITE_DIR, '/') . $infos['path']);
                        $params = ['width' => 125, 'height' => 125];
                        $out .= (new Imager())->imager($src, $params);

                        break;
                    case "devise":
                        setlocale(LC_MONETARY, 'fr_FR');
                        $out .= money_format('%n', $data);
                        break;

                    // TODO
                    case "listselect":
                        if (empty($this->option))
                            die('ERROR 256');

                        if (strpos($data, '_') !== false)
                            list($produit_id, $parent_id) = explode('_', $data);
                        else {
                            $produit_id = $data;
                            $parent_id = "";
                        }
                        if (!empty($parent_id))
                            $out .= "<span style='margin-right:3px;'>Voir la suite</span>";
                        else
                            $out .= "<span style='margin-right:3px;'>" . $data . "</span>";

                        foreach ($this->option as $k => $v) {
                            switch ($k) {
                                case 'group':
                                    $out.= "<a href='" . $module->link_to('modForm', array('id' => $this->curID)) . "#group_" . $v . "'><img alt='popupajax' src='/back/styles/images/search.gif' /></a>";
                                    break;
                                case 'module':
                                    $link = str_replace('%ID%', $this->curID, $v);

                                    if (strpos($data, '_') !== false)
                                        list($produit_id, $parent_id) = explode('_', $data);
                                    else {
                                        $produit_id = $data;
                                        $parent_id = "";
                                    }
                                    //list($produit_id, $parent_id) = explode('_',$data);

                                    $link = str_replace('%1%', $produit_id, $link);
                                    $link = str_replace('%2%', $parent_id, $link);

                                    $link = str_replace('%IMG%', "<img alt='popupajax' src='/back/styles/images/last.gif' />", $link);


                                    if (!empty($data) || $this->param['link'])
                                        $out.= $link;
                                    break;
                                default:
                                    die('ERROR 257');
                            }
                        }
                        break;
                    case "mail":
                        $out.= '<i class="fa fa-envelope-open-o"></i> ';
                        $out.= "<a href='mailto:" . $data . "'>";
                        $out .= $data;
                        $out.= "</a>";
                        break;

                    // TODO
                    case "custom":
                        $this->option[1] = $this->curID;
                        $out .= "<span><a onclick=\"ajax_form('" . $module->link_to('custom', $this->option) . "'); return false;\" href='#'>" . $data . "</a></span>";
                        $out .= "<a onclick=\"ajax_form('" . $module->link_to('custom', $this->option) . "'); return false;\" href='#'>";
                        $out .= "<img alt='popupajax' src='/back/styles/images/comment.gif' />";
                        $out .= "</a>";
                        break;
                    case "translate":
                        $sql = " SELECT l.langue_ini, l.langue_id, l.langue_img, x." . $module->getVar('name_url') . "_nom_id FROM langue l";
                        $sql .= " LEFT JOIN " . $module->getVar('name_url') . "_nom x ON (x.langue_id = l.langue_id AND " . $module->getVar('name_url') . "_id = '" . $this->curID . "')";
                        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
                        $arrLangue = $this->sql->record;
                        foreach ($arrLangue as $tmpLangue) {
                            $isActive = (($tmpLangue[$module->getVar('name_url') . '_nom_id']) ? '' : 'fa-disabled');
                            $out.= "<i class='flag-icon flag-icon-".strtolower($tmpLangue['langue_ini']) . " " . $isActive . "'></i>&nbsp;&nbsp;";
                        }
                        break;
                    case "eip":
                        $uniqueId = uniqid('eip-');
                        $out .= "<a href='#null' id='".$uniqueId."'>";
                        $out .= $data;
                        $out .= "</a>";

                        $out.= "
                            <script>
                                jQuery('#".$uniqueId."').editable({
                                       type:  '".$this->getVar('eip_type')."',
                                       pk:    '".$this->curID."',
                                       url:   '".$this->getVar('eip_url')."',
                                       title:   '".$this->getVar('eip_title')."',
                                       mode: 'inline'
                                    });
                            </script>
                            ";

                        break;
                    case "action":
                        $tooltip = (!empty($this->tooltip)) ? $this->tooltip : '';
                        $out .= '<a href="#null" class="btn btn-default btn-flat" title="'.$tooltip.'" data-toggle="tooltip" onclick="ajax_form(\'' . $this->url . $this->curID . '/\')">'.$this->texte.'</a>';
                        break;
                    case 'html':
                        $out .= htmlentities($data);
                        break;
                    case 'label':
                        // TODO : change color
                        $out .= '<span class="label label-primary">' . $data . '</span>';
                        break;
                    default:
                        if (empty($this->format)) {
                            $out .= $data;
                        } else {
                            $link = str_replace('%ID%', $this->curID, $this->format);
                            $link = str_replace('%1%', $data, $link);
                            $out .= "<span>" . $link . "</span>";
                            $out.= "<img alt='popupajax' src='/back/styles/images/last.gif' />";
                        }
                        break;
                }
            }
            $out .= "</td>";
        }
        return $out;
    }
}
