<?php

class bCms_page extends BackModule
{
    function update($formvars = array(), $table = null, $langue = true)
    {
        if (isset($formvars['parent_id']) && $formvars['parent_id'] == "NULL") {
            unset($formvars['parent_id']);
        }

        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true)
    {
        if (isset($formvars['parent_id']) && $formvars['parent_id'] == "NULL") {
            unset($formvars['parent_id']);
        }

        $formvars['page_nom_url'] = Tools::parseURL($formvars['page_nom_nom']);

        $id = parent::create_multi($formvars, $table, $langue);
        Boutique::getInstance()->createStatut('cms_page', $id);

        return $id;
    }

    function duplicate($formvars = array(), $table = null, $langue = true)
    {

        unset($formvars['page_nom_url']);

        $return = $this->create($formvars, $table, $langue);

        return $return;
    }

    function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'une nouvelle Page</a></span>";
        } else {
            $sql = "SELECT page_nom_nom as data 
                    FROM cms_page_nom 
                    WHERE cms_page_id = '" . $formvars['id'] . "' 
                    AND langue_id = '" . LANGUE . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data         = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id']))
                . "'>Edition de la page : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql .= " FROM cms_page p";
            $sql .= " LEFT JOIN cms_page_nom pn ON(pn.cms_page_id = p.cms_page_id AND pn.langue_id = '" . LANGUE . "')";

            $sql .= " WHERE p.cms_page_id='" . $formvars['id'] . "'";

            $this->request = $sql;

            $sql = "SELECT * FROM cms_page WHERE cms_page_id = '" . $formvars['id'] . "'";
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            $type = $this->sql->record['cms_page_type'];
        } else {
            $type = '';
        }
        //-- SQL
        //GROUP
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);
        //--GROUP
        // Champs du formulaire

        $form = new BackForm("Type", "select", "cms_page_type");
        $form->addAttr('class', 'required');
        $form->addOption('page', 'Standard');
        $form->addOption('block', 'Block');
        $form->addOption('alias', 'Alias');
        $this->addForm($form);

        if (!isset($_GET['p*parent_id']) || empty($_GET['p*parent_id']) || $_GET['p*parent_id'] == 'NULL') {
            $form = new BackForm("Attach&eacute; au menu", "select", "cms_menu_id");
            $form->addAttr('class', 'required');
            $form->addOption("NULL", "---");
            $form->addOptionSQL(array(sprintf("SELECT cms_menu_id, menu_nom_nom FROM cms_menu_nom WHERE langue_id = %d", LANGUE)));
            $this->addForm($form);
        } else {

            $form = new BackForm("Page Parent", "select", "parent_id");
            $form->addOption("NULL", "---");
            $form->addOptionSQL(array("SELECT p.cms_page_id, pn.page_nom_nom FROM cms_page p, cms_page_nom pn WHERE p.parent_id IS NULL AND p.cms_page_id = pn.cms_page_id AND pn.langue_id ='" . LANGUE . "' ORDER BY page_nom_nom", false));
            $this->addForm($form);
        }

        $form = new BackForm("Nom", "text", "page_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        if ($type == Cms::TYPE_STANDARD) {

            $form = new BackForm("Url", "text", "page_nom_url");
            $form->setVar('translate', true);
            $form->addAttr('class', 'required');
            $this->addForm($form);

            $form = new BackForm("Image Listing", "image", "page_nom_image");
            $form->setVar('translate', true);
            $this->addForm($form);

        }

        if ($type == Cms::TYPE_STANDARD) {

            $form = new BackForm("Contenu", "tinymce", "page_nom_contenu");
            $form->setVar('translate', true);
            $this->addForm($form);
        }

        if ($type == Cms::TYPE_ALIAS) {
            $form = new BackForm("Page", "select", "alias_id");
            $form->addAttr('class', 'required');
            $form->addOptionSQL(array(
                "SELECT p.cms_page_id, CONCAT(pn.page_nom_nom, ' ( /p-', pn.page_nom_url, '.html )') 
                                        FROM cms_page p, cms_page_nom pn 
                                        WHERE p.cms_page_id <> '" . $formvars['id'] . "' 
                                        AND p.cms_page_id = pn.cms_page_id 
                                        AND pn.langue_id ='" . LANGUE . "' 
                                        ORDER BY page_nom_nom",
                false
            ));
            $this->addForm($form);
        }

        $form = new BackForm("Statut", "select", "page_statut_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array("SELECT page_statut_id, page_statut_nom FROM cms_page_statut"));
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "page_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'cms_page_boutique');
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id'])) {
            $formvars['id'] = 0;
        }

        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array())
    {

        // RECHERCHE
        $form = new BackForm("Nom", "text", "pn.page_nom_nom");
        $form->setVar("compare", "LIKE");
        $this->addForm($form);

        $form = new BackForm("Position", "select", "mp.menu_position_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT menu_position_id, menu_position_nom FROM cms_menu_position"));
        $this->addForm($form);

        $form = new BackForm("Menu", "select", "p.cms_menu_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT m.cms_menu_id, CONCAT(mn.menu_nom_nom, ' (', mp.menu_position_nom, ')')  
                                      FROM cms_menu m 
                                      LEFT JOIN cms_menu_nom mn ON(mn.cms_menu_id = m.cms_menu_id AND mn.langue_id = '" . LANGUE . "')
                                      LEFT JOIN cms_menu_position mp ON(mp.menu_position_id = m.menu_position_id)"));
        $this->addForm($form);

        $form = new BackForm("Type", "select", "p.cms_page_type");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOption('page', 'Standard');
        $form->addOption('alias', 'Alias');
        $this->addForm($form);

        $form = new BackForm("Boutique", "select", "pb.boutique_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT boutique_id, boutique_nom FROM boutique"));
        $this->addForm($form);
        //-- RECHERCHE

        $sql = "SELECT p.cms_page_id, p.cms_page_id";
        $sql .= ", p.cms_page_type";
        $sql .= ", pn.page_nom_nom";
        $sql .= ", mn.menu_nom_nom";
        $sql .= ", mp.menu_position_nom";
        $sql .= ", pn.page_nom_url";
        $sql .= ", p.page_rang";
        $sql .= ", CONCAT('<img src=\"/back/styles/images/actif', p.page_statut_id, '.png\" />')";
        $sql .= " FROM (cms_page p)";
        $sql .= " LEFT JOIN cms_page_nom pn on (pn.cms_page_id = p.cms_page_id)";
        $sql .= " LEFT JOIN cms_page pe on (pe.parent_id = p.cms_page_id)";
        $sql .= " LEFT JOIN cms_menu_nom mn on (mn.cms_menu_id = p.cms_menu_id)";
        $sql .= " LEFT JOIN cms_menu cm on (mn.cms_menu_id = cm.cms_menu_id)";
        $sql .= " LEFT JOIN cms_menu_position mp on (cm.menu_position_id = mp.menu_position_id)";

        $sql .= "WHERE 1";
        if (!isset($_GET['p*parent_id']) || empty($_GET['p*parent_id']) || $_GET['p*parent_id'] == 'NULL') {
            $sql .= " AND p.parent_id IS NULL";
        }
        if (!empty($formvars['menu'])) {
            $sql .= " AND p.menu_id = '" . $formvars['menu'] . "'";
        }

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("TYPE");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("MENU");
        $this->addLabel($label);

        $label = new BackLabel("POSITION");
        $this->addLabel($label);

        $label = new BackLabel("URL");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("PUBLIE");
        $label->setVar('align', 'center');
        $this->addLabel($label);

        $label = new BackLabel("TRADUCTIONS", 'translate');
        $this->addLabel($label);

        //-- LABELS

        return $this->displayList($formvars['type']);
    }
}
