<?php

class bProduit extends BackModule {

    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
        $GLOBALS['displayMcFileManager'] = true;
    }

    function update($formvars = array(), $table = null, $langue = true) {

        $return = parent::update_multi($formvars, $table, $langue);

        return $return;
    }

    function duplicate($formvars = array(), $table = null, $langue = true) {

        $return = $this->create($formvars, $table, $langue);

        // Duplicate des categories
        $sql = "INSERT INTO produit_categorie (produit_id,categorie_id, produit_categorie_default)";
        $sql.=" SELECT '" . $return . "',categorie_id, produit_categorie_default FROM produit_categorie WHERE produit_id = '" . $formvars['back_id'] . "'";
        $this->sql->query($sql);

        return $return;
    }

    function create($formvars = array(), $table = null, $langue = true) {
        if (empty($formvars['produit_date_parution'])) {
            unset($formvars['produit_date_parution']);
        }
        $return = parent::create_multi($formvars, $table, $langue);

        // mise a jour des stocks a faire dans tous les cas pour init le stock
        $stock = new Stock;
        $qte = (int)$formvars['produit_quantite_p_new'] - (int)$formvars['produit_quantite_p'];
        $stock->mouvement($return, '', '', '', $qte, $formvars['produit_achat'], 'in', 'in', 'Stock Initial');

        Boutique::getInstance()->createStatut('produit', $return);

        return $return;
    }

    function Form($formvars = array()) {

        if (empty($formvars['id']))
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'un nouveau produit</a></span>";
        else {
            $sql = "SELECT CONCAT(pn.produit_nom_nom,' - #', pn.produit_id ,'') as data FROM produit_nom pn WHERE produit_id = '" . $formvars['id'] . "' AND pn.langue_id = '" . LANGUE . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];

            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition du produit : <strong>" . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql.=" FROM (produit p, taxe t)";
            $sql.=" LEFT JOIN produit_nom pn ON (pn.produit_id = p.produit_id)";
            $sql.=" WHERE p.produit_id = '" . $formvars['id'] . "'";
            $sql.=" AND t.taxe_id = p.taxe_id	";

            $this->request = $sql;
        }
        //-- SQL
        // Champs du formulaire
        //GROUP
        $form = new BackForm("Identification du produit", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Nom", "text", "produit_nom_nom");
        $form->addAttr('class', 'required');
        $form->setVar('translate', true);
        $this->addForm($form);

        $form = new BackForm("Marque", "select", "marque_id");
        $form->addOption('NULL', '---');
        $form->addOptionSQL(array("SELECT marque_id, marque_nom FROM (marque) ORDER BY marque_nom"));
        $this->addForm($form);

        $form = new BackForm("Fournisseur", "select", "fournisseur_id");
        $form->addOption('NULL', '---');
        $form->addOptionSQL(array("SELECT fournisseur_id, fournisseur_nom FROM (fournisseur) ORDER BY fournisseur_nom"));
        $this->addForm($form);

        $form = new BackForm("Taxe", "select", "taxe_id");
        $form->addOptionSQL(array("SELECT taxe_id, taxe_nom FROM (taxe) ORDER BY taxe_nom"));
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "produit_rang");
        $this->addForm($form);

        $form = new BackForm("Type du produit", "select", "produit_type_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array("SELECT produit_type_id, produit_type_libelle FROM (produit_type) ORDER BY produit_type_id"));
        $this->addForm($form);
        
        $form = new BackForm("Statut", "select", "produit_statut_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array("SELECT produit_statut_id, produit_statut_nom FROM (produit_statut) ORDER BY produit_statut_id"));
        $this->addForm($form);

        $form = new BackForm("Date de parution", "datetime", "produit_date_parution");
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'produit_boutique');
        $this->addForm($form);

        $form = new BackForm("Attributs", "group");
        $form->addGroupOpts('class', 'produit_attribut');
        $this->addForm($form);

        $form = new BackForm("Promotions", "group");
        $form->addGroupOpts('class', 'produit_prix_barre');
        $this->addForm($form);

        //GROUP
        $form = new BackForm("Descriptifs Produits", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Description", "tinymce", "produit_nom_desc");
        $form->setVar('translate', true);
        $this->addForm($form);

        $form = new BackForm("Images", "group");
        $form->addGroupOpts('class', 'produit_image');
        $this->addForm($form);

        $form = new BackForm("Categories", "group");
        $form->addGroupOpts('class', 'produit_categorie');
        $this->addForm($form);

        $form = new BackForm("Caractéristiques", "group");
        $form->addGroupOpts('class', 'produit_caracteristique_valeur');
        $this->addForm($form);

        $form = new BackForm("Produits Associes", "group");
        $form->addGroupOpts('class', 'produit_assoc');
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array()) {

        $this->openSearch = false;

        // RECHERCHE
        $form = new BackForm("# PRODUIT", "text", "p.produit_id");
        $form->setVar("compare", "EQUAL");
        $this->addForm($form);

        $form = new BackForm("Ean", "text", "p.produit_ean");
        $form->setVar("compare", "LIKE");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "pn.produit_nom_nom");
        $form->setVar("compare", "LIKE");
        $this->addForm($form);

        $form = new BackForm("Cat&eacute;gorie", "select", "pc.categorie_id");
        $form->setVar("compare", "SPEC");
        $form->addOption("", "---");
        $form->addOptionSQL(
                array(
                    array("SELECT c.categorie_id, cn.categorie_nom_nom FROM (categorie c,categorie_nom cn) WHERE parent_id IS NULL AND cn.langue_id='" . LANGUE . "' AND c.categorie_id=cn.categorie_id ORDER BY categorie_rang, categorie_nom_nom", false),
                    array("SELECT c.categorie_id, cn.categorie_nom_nom FROM categorie c,categorie_nom cn WHERE parent_id = '%ID%' AND c.categorie_id = cn.categorie_id AND cn.langue_id ='" . LANGUE . "' ORDER BY categorie_rang, categorie_nom_nom", true),
                )
        );
        $this->addForm($form);

        $form = new BackForm("Marque", "select", "p.marque_id");
        $form->setVar("compare", "EQUAL");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT marque_id, marque_nom FROM (marque) ORDER BY marque_nom"));
        $this->addForm($form);

        $form = new BackForm("Fournisseur", "select", "p.fournisseur_id");
        $form->setVar("compare", "EQUAL");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT f.fournisseur_id, f.fournisseur_nom FROM (fournisseur f) ORDER BY fournisseur_nom"));
        $this->addForm($form);

        $form = new BackForm("Type du produit", "select", "p.produit_type_id");
        $form->setVar("compare", "EQUAL");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT pt.produit_type_id, pt.produit_type_libelle FROM (produit_type pt) ORDER BY produit_type_id"));
        $this->addForm($form);

        $form = new BackForm("Boutique", "select", "pb.boutique_id");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT boutique_id, boutique_nom FROM boutique ORDER BY boutique_id"));
        $this->addForm($form);

        $form = new BackForm("Statut Produit", "statut", "p.produit_statut_id", array('1', '2'));
        $form->setVar("compare", "EQUAL");
        $this->addForm($form);
        //-- RECHERCHE
        // SQL
        $sql = "SELECT p.produit_id";
        $sql.=", p.produit_id";
        $sql.=", pn.produit_nom_nom";
        $sql.=", (SELECT SUM(pa.produit_attribut_quantite) FROM produit_attribut pa WHERE pa.produit_id = p.produit_id) AS produit_quantite";
        $sql.=", ROUND(MIN(patt.produit_attribut_prix) * (1 + taxe_taux),2)";
        $sql.=", COUNT(DISTINCT patt.produit_attribut_id) AS nb_attributs";
        $sql.=", COUNT(DISTINCT produit_categorie_id) AS nb_categories";
        $sql.=", COUNT(DISTINCT pi.produit_image_id) AS nb_images";
        $sql.=", ps.produit_statut_image";

        $sql.=" FROM (produit p, taxe t)";
        $sql.=" LEFT JOIN produit_categorie pc ON (pc.produit_id = p.produit_id)";
        $sql.=" LEFT JOIN categorie c ON (pc.categorie_id = c.categorie_id)";
        $sql.=" LEFT JOIN produit_attribut patt ON (patt.produit_id = p.produit_id)";
        $sql.=" LEFT JOIN produit_image pi ON (pi.produit_id = p.produit_id)";
        $sql.=" LEFT JOIN produit_statut ps ON (ps.produit_statut_id = p.produit_statut_id)";
        $sql.=" LEFT JOIN produit_nom pn ON (pn.produit_id = p.produit_id AND pn.langue_id='" . LANGUE . "')";
        //$sql.=" LEFT JOIN produit_prix_barre ppb ON (p.produit_id = ppb.produit_id AND ppb.produit_attribut_id IS NULL AND ppb.produit_prix_barre_date_debut <= NOW() AND ppb.produit_prix_barre_date_fin >= NOW())";
        //$sql.=" LEFT JOIN produit_prix_barre ppb_att ON (p.produit_id = ppb_att.produit_id AND ppb_att.produit_attribut_id IS NOT NULL AND ppb_att.produit_prix_barre_date_debut <= NOW() AND ppb_att.produit_prix_barre_date_fin >= NOW())";

        $sql.=" LEFT JOIN produit_boutique pb ON (pb.produit_id = p.produit_id)";

        $sql.=" WHERE 1";
        $sql.=" AND t.taxe_id = p.taxe_id";

        if (!empty($_GET['pc*categorie_id'])) {
            $sql.=" AND (c.categorie_id = '" . $_GET['pc*categorie_id'] . "' OR c.parent_id = '" . $_GET['pc*categorie_id'] . "')";
        }

        $this->request = $sql;

        //-- SQL
        // LABELS

        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM", "left");
        $this->addLabel($label);

        $label = new BackLabel("Quantit&eacute; en stock");
        $label->setVar('abr', "STOCK");
        $this->addLabel($label);

        $label = new BackLabel("PRIX TTC", "devise");
        $this->addLabel($label);

        $label = new BackLabel("NOMBRE D'ATTRIBUTS", "listselect", "ATTRIBUT");
        $label->setVar('option', array("group" => "produit_attribut"));
        $this->addLabel($label);

        $label = new BackLabel("NOMBRE DE CATEGORIES", "listselect", "CATEGORIES");
        $label->setVar('option', array("group" => "produit_categorie"));
        $this->addLabel($label);

        $label = new BackLabel("NOMBRE D'IMAGES", "listselect", "PHOTO");
        $label->setVar('option', array("group" => "produit_image"));
        $this->addLabel($label);


        $label = new BackLabel("STATUT", "statut_v2");
        $this->addLabel($label);

        $label = new BackLabel("TRADUCTIONS", 'translate');
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    function autocomplete($formvars = array()) {
        $out = array();
        if (isset($formvars['q']) && !empty($formvars['q'])) {
            $produit = new Produit();
            $arrArt = $produit->getAutoComplete(array('search' => $formvars['q']));

            foreach ($arrArt as $arti) {
                $out[] = array(
                    'id' => $arti['produit_id'],
                    'text' => $this->formatTextAutocomplete($arti),
                );
            }

            if (!$out) {
                $out = array("Entrez le nom d'un produit");
            }
        } else {
            $out = array("Entrez le nom d'un produit");
        }

        return json_encode(array('results' => $out));
    }

    function formatTextAutocomplete($result)
    {
        return $result['produit_nom_nom'];
    }

    /**
     * Utile pour init le select lors de l'edition
     *
     * @param array $formvars
     * @return mixed
     * @throws Exception
     */
    function getAutocomplete($formvars = array()) {
        $produit = new Produit();
        $results = $produit->getAutoComplete(array('id' => $formvars['id']));

        return $this->formatTextAutocomplete($results[0]);
    }

//--
}