<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddPrixBarre extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("prix_barre_prefix", ['id' => false, 'primary_key' => ["prix_barre_prefix_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_prefix_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'signed' => false])
            ->addColumn('prix_barre_prefix_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'prix_barre_prefix_id'])
            ->create();

        $this
            ->table("prix_barre_statut", ['id' => false, 'primary_key' => ["prix_barre_statut_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_statut_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_statut_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'prix_barre_statut_id'])
            ->create();

        $this
            ->table("prix_barre", ['id' => false, 'primary_key' => ["prix_barre_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'prix_barre_id'])
            ->addColumn('prix_barre_prix', 'decimal', ['null' => false, 'default' => '0.0000', 'precision' => 15, 'scale' => 4, 'after' => 'prix_barre_nom'])
            ->addColumn('prix_barre_prefix_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_prix', 'signed' => false])
            ->addColumn('prix_barre_date_ajout', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'prix_barre_prefix_id'])
            ->addColumn('prix_barre_date_modif', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'prix_barre_date_ajout'])
            ->addColumn('prix_barre_date_debut', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'prix_barre_date_modif'])
            ->addColumn('prix_barre_date_fin', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'prix_barre_date_debut'])
            ->addColumn('prix_barre_statut_id', 'integer', ['null' => false, 'default' => '0', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_date_fin', 'signed' => false])
            ->addColumn('prix_barre_all', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_statut_id'])
            ->addColumn('etiquette_id', 'integer', ['null' => true, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_all', 'signed' => false])
            ->addForeignKey('prix_barre_prefix_id', 'prix_barre_prefix', 'prix_barre_prefix_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('prix_barre_statut_id', 'prix_barre_statut', 'prix_barre_statut_id', array(
                'delete' => 'RESTRICT',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('etiquette_id', 'etiquette', 'etiquette_id', array(
                'delete' => 'SET NULL',
                'update' => 'CASCADE'
            ))
            ->addIndex(['prix_barre_statut_id'], ['name' => "produit_statut_id", 'unique' => false])
            ->addIndex(['prix_barre_prefix_id'], ['name' => "prix_barre_prefix_id", 'unique' => false])
            ->addIndex(['prix_barre_id', 'prix_barre_statut_id'], ['name' => "prix_barre_id", 'unique' => false])
            ->addIndex(['prix_barre_date_fin'], ['name' => "prix_barre_date_fin", 'unique' => false])
            ->addIndex(['prix_barre_date_debut'], ['name' => "prix_barre_date_debut", 'unique' => false])
            ->addIndex(['prix_barre_id', 'prix_barre_date_debut', 'prix_barre_date_fin', 'prix_barre_statut_id'], ['name' => "prix_barre_id_2", 'unique' => false])
            ->addIndex(['prix_barre_all'], ['name' => "prix_barre_all", 'unique' => false])
            ->addIndex(['etiquette_id'], ['name' => "etiquette_id", 'unique' => false])
            ->create();

        $this
            ->table("prix_barre_boutique", ['id' => false, 'primary_key' => ["prix_barre_boutique_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_boutique_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_boutique_id', 'signed' => false])
            ->addColumn('boutique_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_id', 'signed' => false])
            ->addColumn('prix_barre_boutique_statut_id', 'integer', ['null' => false, 'default' => '1', 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'boutique_id'])
            ->addForeignKey('prix_barre_id', 'prix_barre', 'prix_barre_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('boutique_id', 'boutique', 'boutique_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['prix_barre_id', 'boutique_id'], ['name' => "prix_barre_id_2", 'unique' => true])
            ->addIndex(['prix_barre_id'], ['name' => "prix_barre_id", 'unique' => false])
            ->addIndex(['boutique_id'], ['name' => "boutique_id", 'unique' => false])
            ->addIndex(['prix_barre_boutique_statut_id'], ['name' => "prix_barre_boutique_statut_id", 'unique' => false])
            ->create();

        $this
            ->table("prix_barre_categorie", ['id' => false, 'primary_key' => ["prix_barre_categorie_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_categorie_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_categorie_id', 'signed' => false])
            ->addColumn('categorie_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_id', 'signed' => false])
            ->addColumn('prix_barre_categorie_inclus', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'categorie_id', 'length' => 1])
            ->addForeignKey('prix_barre_id', 'prix_barre', 'prix_barre_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('categorie_id', 'categorie', 'categorie_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['prix_barre_id', 'categorie_id'], ['name' => "categorie_id_2", 'unique' => true])
            ->addIndex(['prix_barre_id'], ['name' => "prix_barre_id", 'unique' => false])
            ->addIndex(['categorie_id'], ['name' => "categorie_id", 'unique' => false])
            ->addIndex(['prix_barre_categorie_inclus'], ['name' => "prix_barre_categorie_inclus", 'unique' => false])
            ->create();

        $this
            ->table("prix_barre_fournisseur", ['id' => false, 'primary_key' => ["prix_barre_fournisseur_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_fournisseur_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_fournisseur_id', 'signed' => false])
            ->addColumn('fournisseur_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_id', 'signed' => false])
            ->addColumn('prix_barre_fournisseur_inclus', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'fournisseur_id', 'length' => 1])
            ->addForeignKey('prix_barre_id', 'prix_barre', 'prix_barre_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('fournisseur_id', 'fournisseur', 'fournisseur_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['prix_barre_id', 'fournisseur_id'], ['name' => "fournisseur_id_2", 'unique' => true])
            ->addIndex(['prix_barre_id'], ['name' => "prix_barre_id", 'unique' => false])
            ->addIndex(['fournisseur_id'], ['name' => "fournisseur_id", 'unique' => false])
            ->addIndex(['prix_barre_fournisseur_inclus'], ['name' => "prix_barre_fournisseur_inclus", 'unique' => false])
            ->create();

        $this
            ->table("prix_barre_marque", ['id' => false, 'primary_key' => ["prix_barre_marque_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('prix_barre_marque_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('prix_barre_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_marque_id', 'signed' => false])
            ->addColumn('marque_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'prix_barre_id', 'signed' => false])
            ->addColumn('prix_barre_marque_inclus', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'marque_id', 'length' => 1])
            ->addForeignKey('prix_barre_id', 'prix_barre', 'prix_barre_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addForeignKey('marque_id', 'marque', 'marque_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['prix_barre_id', 'marque_id'], ['name' => "marque_id_2", 'unique' => true])
            ->addIndex(['prix_barre_id'], ['name' => "prix_barre_id", 'unique' => false])
            ->addIndex(['marque_id'], ['name' => "marque_id", 'unique' => false])
            ->addIndex(['prix_barre_marque_inclus'], ['name' => "prix_barre_marque_inclus", 'unique' => false])
            ->create();
    }
}
