<?php

/**
 * Class ClientCookie
 *
 * @property int $client_cookie_id
 * @property int $client_id
 * @property int $boutique_id
 * @property bool $client_cookie_consent
 * @property string $client_cookie_date_ajout
 * @property string $client_cookie_date_modif
 * @property string $client_cookie_ip
 */
class ClientCookie extends Model
{
    protected $table = 'client_cookie';

    public function __construct($id = null)
    {
        parent::__construct($id);
    }

    public function getByClientId($clientId)
    {
        return $this->get(['client_id' => $clientId, 'boutique_id' => Boutique::getInstance()->id]);
    }

    public function getByIp($ip)
    {
        return $this->get(['client_cookie_ip' => $ip, 'boutique_id' => Boutique::getInstance()->id]);
    }

    /**
     * @return int
     */
    public function getClientCookieId()
    {
        return $this->client_cookie_id;
    }

    /**
     * @return int
     */
    public function getBoutiqueId()
    {
        return $this->boutique_id;
    }

    /**
     * @param int $client_cookie_id
     * @return ClientCookie
     */
    public function setClientCookieId($client_cookie_id)
    {
        $this->client_cookie_id = $client_cookie_id;
        return $this;
    }

    /**
     * @return int
     */
    public function getClientId()
    {
        return $this->client_id;
    }

    /**
     * @param int $client_id
     * @return ClientCookie
     */
    public function setClientId($client_id)
    {
        $this->client_id = $client_id;
        return $this;
    }

    /**
     * @return bool
     */
    public function isClientCookieConsent()
    {
        return $this->client_cookie_consent;
    }

    /**
     * @param bool $client_cookie_consent
     * @return ClientCookie
     */
    public function setClientCookieConsent($client_cookie_consent)
    {
        $this->client_cookie_consent = $client_cookie_consent;
        return $this;
    }

    /**
     * @return string
     */
    public function getClientCookieDateAjout()
    {
        return $this->client_cookie_date_ajout;
    }

    /**
     * @param string $client_cookie_date_ajout
     * @return ClientCookie
     */
    public function setClientCookieDateAjout($client_cookie_date_ajout)
    {
        $this->client_cookie_date_ajout = $client_cookie_date_ajout;
        return $this;
    }

    /**
     * @return string
     */
    public function getClientCookieDateModif()
    {
        return $this->client_cookie_date_modif;
    }

    /**
     * @param string $client_cookie_date_modif
     * @return ClientCookie
     */
    public function setClientCookieDateModif($client_cookie_date_modif)
    {
        $this->client_cookie_date_modif = $client_cookie_date_modif;
        return $this;
    }

    /**
     * @return string
     */
    public function getClientCookieIp()
    {
        return $this->client_cookie_ip;
    }

    /**
     * @param string $client_cookie_ip
     * @return ClientCookie
     */
    public function setClientCookieIp($client_cookie_ip)
    {
        $this->client_cookie_ip = $client_cookie_ip;
        return $this;
    }

    /**
     * @param int $boutique_id
     */
    public function setBoutiqueId(int $boutique_id)
    {
        $this->boutique_id = $boutique_id;
    }
}