<?php

namespace Controller;

use Form\RegisterForm;
use Pays;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Texte;
use Client;
use Exception;

use Symfony\Component\Routing\Annotation\Route;

/**
 * Class RegisterController
 * @package Controller
 *
 */
class RegisterController extends Controller {

    /**
     * @Route("/register", name="inscription", methods = { "GET" })
     *
     * @return mixed
     */
    public function show_register()
    {
        $pays = new Pays();
        $client = new Client();

        if (!empty($post['origin'])) {
            $origin = $post['origin'];
        } else {
            $origin = $this->request->get('origin');
        }

        $this->template->assign('origin', $origin);
        $this->template->assign('pays', $pays->get());
        $this->template->assign('civilites', $client->getCivilite());
        $this->template->assign('hydrateForm', ['client_email' => $this->request->get('client_email')]);

        return $this->render('register.tpl');
    }

    /**
     * @Route("/register", name="inscription_post", methods = { "POST" })
     *
     */
    public function post_register()
    {
        $post = $this->request->request->all();

        if (!empty($post['origin'])) {
            $origin = $post['origin'];
        } else {
            $origin = $this->request->get('origin');
        }

        if(!empty($post['client_ddn_Year']) && !empty($post['client_ddn_Month']) && !empty($post['client_ddn_Day'])) {
            $date = $post['client_ddn_Year'] . "-" . str_pad($post['client_ddn_Month'], 2, "0", STR_PAD_LEFT) . "-" . str_pad($post['client_ddn_Day'], 2, "0", STR_PAD_LEFT);
            $this->request->request->set('client_ddn',$date);
            $post['client_ddn'] = $date;
        }

        $form = new RegisterForm();
        $error = $form->handle($this->request);

        if(!empty($error)) {
            $json['field_errors'] = json_encode($error);
        } else {

            $client = new Client();
            $texte = new Texte();

            try {
                $idClient = $client->add($post);

                if (!empty($idClient)) {
                    $customer = new Client($idClient);
                    $client->setSession($this->request->getSession(), $customer->toArray());
                    if (!empty($origin)) {
                        $json['redirect'] = $origin;
                    } else {
                        $json['redirect'] = $this->generateUrl('compte');
                    }
                }

            } catch(Exception $e) {
                error_log($e->getMessage());
                error_log($e->getTraceAsString());
                $json['error'] = $texte->getOneOrCreate(
                'errCreationClient',
                'Une erreur lors la création de votre compte est survenue. Veuillez réessayer ultérieurement.'
                );
            }


        }

        return $this->response($json);
    }
}
