<?php

namespace Form;

use Form\Constraint\Mail;
use Form\Constraint\NotBlank;

class LoginForm extends Form
{
    function __construct()
    {
        parent::__construct();
        $texte = new \Texte();

        $this
            ->add(
                new Field(
                    "client_email",
                    array(
                        "not_empty" => new NotBlank(),
                        "is_mail" => new Mail(),
                    ),
                    array(
                        "not_empty" => $texte->getOneOrCreate("email_obligatoire", "Vous devez remplir votre email."),
                        "is_mail" => $texte->getOneOrCreate("email_invalide", "Vous devez utiliser un email correct."),
                    )
                )
            )
            ->add(
                new Field(
                    "client_password",
                    array(
                        "not_empty" => new NotBlank(),
                    ),
                    array(
                        "not_empty" => $texte->getOneOrCreate("password_obligatoire", "Vous devez remplir le champ de mot de passe.")
                    )
                )
            )
        ;
    }
}