<!--form/register.tpl-->
<form method="post" id="form_inscription" name="register" class="form formRegister" action="{url page='inscription_post'}" data-ajf>

    <div class="card-body">
        <div data-result>
            {include file="elements/alert.tpl" tag="p" context="" class="" icon=false text=""}
        </div>

        <div class="row">
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="client_email" required=true label={txt value="Email"} required=true}
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/password.tpl" name="client_password" required=true label={txt value="Mot de passe"}}
                </div>
            </div>
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/password.tpl" name="client_password_confirm" required=true label={txt value="Confirmation du mot de passe"}}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-sm-6">
                <div class="form-group radioList">
                    <label class="radioListLabel">{txt value="Civilité"}</label>
                    {foreach $civilites as $civilite}
                        {include file="form/input/checkbox.tpl" inputType="radio" name="civilite_id" id=uniqid() label=$civilite.civilite_nom_nom value=$civilite.civilite_id}
                    {/foreach}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="client_nom" required=true label={txt value="Nom"}}
                </div>
            </div>
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="client_prenom" required=true label={txt value="Prénom"}}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="adresse_rue" required=true label={txt value="Adresse"}}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="adresse_rue2" label={txt value="Complément d'adresse"}}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-sm-4">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="adresse_cp" required=true label={txt value="Code Postal"}}
                </div>
            </div>
            <div class="col-12 col-sm-8">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="adresse_ville" required=true label={txt value="Ville"}}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12 col-sm-6">
                <div class="form-group">
                    {include file="form/input/text.tpl" name="client_telephone" required=true label={txt value="Téléphone"}}
                </div>
            </div>
            <div class="col-12 col-sm-6">
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    {include file="form/input/select.tpl" name="pays_id" values=Tools::formatAssoc($pays, 'pays_id', 'pays_nom_nom') label={txt value="Pays"} required=true}
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12">
                <div class="form-group checkboxList">
                    {include file="form/input/checkbox.tpl" name="client_newsletter_id" value=1 label={txt key="inscription_newsletter_texte" value="Je souhaite m’inscrire à la newsletter pour être informé des nouvelles offres."}}
                </div>
            </div>
        </div>

        <div class="row mt-3 mb-3">
            <div class="col-12">
                <div class="text-muted">{txt key="form_cnil" value="Conformément à la loi “informatiques et libertés”, vous bénéficiez d’un droit d’accès et de rectification aux informations qui vous concernent. Pour en savoir plus, consultez notre <a href='#'>politique de confidentialité</a>."}</div>
            </div>
        </div>
    </div>

    <div class="card-footer">
        <em class="text-muted">
            {txt value="* champs obligatoires"}
        </em>
        <button type="submit" class="btn btn-secondary">{txt value="Créer mon compte"}</button>
    </div>
</form>
